package vn.teko.auth.auth_flutter

import vn.teko.android.auth.data.model.IamToken
import vn.teko.android.auth.data.model.IdToken
import vn.teko.android.auth.data.model.User

object FlutterModelUtils {

    fun createSuccessCommonResult(): AuthFlutter.CommonAuthResult {
        return AuthFlutter.CommonAuthResult().apply { isSuccess = true }
    }

    fun createErrorCommonResult(error: String? = null): AuthFlutter.CommonAuthResult {
        return AuthFlutter.CommonAuthResult().apply {
            isSuccess = false
            this.error = error
        }
    }

    fun createSuccessAccessTokenResult(token: IamToken): AuthFlutter.AccessTokenResult {
        return AuthFlutter.AccessTokenResult().apply {
            isSuccess = true
            iamToken = AuthFlutter.IamToken().also {
                it.id = token.id.toString()
                it.accessToken = token.accessToken
                it.refreshToken = token.refreshToken
                it.expiresIn = token.expiresIn.toLong()
                it.tokenType = token.tokenType
            }
        }
    }

    fun createSuccessIdTokenResult(token: IdToken): AuthFlutter.IdTokenResult {
        return AuthFlutter.IdTokenResult().apply {
            isSuccess = true
            idToken = AuthFlutter.IdToken().also {
                it.idToken = token.idToken
                it.accessToken = token.accessToken
                it.refreshToken = token.refreshToken
                it.expiresIn = token.expiresIn?.toLong()
                it.tokenType = token.tokenType
            }
        }
    }

    fun createErrorAccessTokenResult(error: String?): AuthFlutter.AccessTokenResult {
        return AuthFlutter.AccessTokenResult().apply {
            isSuccess = false
            this.error = error
        }
    }

    fun createErrorIdTokenResult(error: String?): AuthFlutter.IdTokenResult {
        return AuthFlutter.IdTokenResult().apply {
            isSuccess = false
            this.error = error
        }
    }

    fun convertKotlinUserToFlutterUser(user: User) =
        AuthFlutter.UserInfo().also { flutterUser ->
            flutterUser.sub = user.sub
            flutterUser.name = user.name
            flutterUser.picture = user.picture
            flutterUser.email = user.email
            flutterUser.phoneNumber = user.phoneNumber
            flutterUser.birthday = user.birthday
            flutterUser.address = user.address
            flutterUser.roles = user.roles
            flutterUser.permissions = user.permissions
            flutterUser.metadata = user.metadata
        }
}