// Autogenerated from Pigeon (v2.0.4), do not edit directly.
// See also: https://pub.dev/packages/pigeon
#import <Foundation/Foundation.h>
@protocol FlutterBinaryMessenger;
@protocol FlutterMessageCodec;
@class FlutterError;
@class FlutterStandardTypedData;

NS_ASSUME_NONNULL_BEGIN

@class CommonAuthResult;
@class IsAuthorizedResult;
@class LogoutResult;
@class AccessTokenResult;
@class IdTokenResult;
@class IamToken;
@class IdToken;
@class AppleCredential;
@class GoogleCredential;
@class FacebookCredential;
@class PhoneOtpCredential;
@class UsernamePasswordCredential;
@class CustomCredential;
@class UserInfoResult;
@class UserInfo;

@interface CommonAuthResult : NSObject
+ (instancetype)makeWithIsSuccess:(nullable NSNumber *)isSuccess
    error:(nullable NSString *)error;
@property(nonatomic, strong, nullable) NSNumber * isSuccess;
@property(nonatomic, copy, nullable) NSString * error;
@end

@interface IsAuthorizedResult : NSObject
+ (instancetype)makeWithIsAuthorized:(nullable NSNumber *)isAuthorized
    isSuccess:(nullable NSNumber *)isSuccess
    error:(nullable NSString *)error;
@property(nonatomic, strong, nullable) NSNumber * isAuthorized;
@property(nonatomic, strong, nullable) NSNumber * isSuccess;
@property(nonatomic, copy, nullable) NSString * error;
@end

@interface LogoutResult : NSObject
+ (instancetype)makeWithIsLoggedOut:(nullable NSNumber *)isLoggedOut
    isSuccess:(nullable NSNumber *)isSuccess
    error:(nullable NSString *)error;
@property(nonatomic, strong, nullable) NSNumber * isLoggedOut;
@property(nonatomic, strong, nullable) NSNumber * isSuccess;
@property(nonatomic, copy, nullable) NSString * error;
@end

@interface AccessTokenResult : NSObject
+ (instancetype)makeWithIsSuccess:(nullable NSNumber *)isSuccess
    error:(nullable NSString *)error
    iamToken:(nullable IamToken *)iamToken;
@property(nonatomic, strong, nullable) NSNumber * isSuccess;
@property(nonatomic, copy, nullable) NSString * error;
@property(nonatomic, strong, nullable) IamToken * iamToken;
@end

@interface IdTokenResult : NSObject
+ (instancetype)makeWithIsSuccess:(nullable NSNumber *)isSuccess
    error:(nullable NSString *)error
    idToken:(nullable IdToken *)idToken;
@property(nonatomic, strong, nullable) NSNumber * isSuccess;
@property(nonatomic, copy, nullable) NSString * error;
@property(nonatomic, strong, nullable) IdToken * idToken;
@end

@interface IamToken : NSObject
+ (instancetype)makeWithId:(nullable NSString *)id
    accessToken:(nullable NSString *)accessToken
    refreshToken:(nullable NSString *)refreshToken
    expiresIn:(nullable NSNumber *)expiresIn
    tokenType:(nullable NSString *)tokenType;
@property(nonatomic, copy, nullable) NSString * id;
@property(nonatomic, copy, nullable) NSString * accessToken;
@property(nonatomic, copy, nullable) NSString * refreshToken;
@property(nonatomic, strong, nullable) NSNumber * expiresIn;
@property(nonatomic, copy, nullable) NSString * tokenType;
@end

@interface IdToken : NSObject
+ (instancetype)makeWithIdToken:(nullable NSString *)idToken
    accessToken:(nullable NSString *)accessToken
    refreshToken:(nullable NSString *)refreshToken
    expiresIn:(nullable NSNumber *)expiresIn
    tokenType:(nullable NSString *)tokenType;
@property(nonatomic, copy, nullable) NSString * idToken;
@property(nonatomic, copy, nullable) NSString * accessToken;
@property(nonatomic, copy, nullable) NSString * refreshToken;
@property(nonatomic, strong, nullable) NSNumber * expiresIn;
@property(nonatomic, copy, nullable) NSString * tokenType;
@end

@interface AppleCredential : NSObject
+ (instancetype)makeWithAccessToken:(nullable NSString *)accessToken;
@property(nonatomic, copy, nullable) NSString * accessToken;
@end

@interface GoogleCredential : NSObject
+ (instancetype)makeWithAccessToken:(nullable NSString *)accessToken;
@property(nonatomic, copy, nullable) NSString * accessToken;
@end

@interface FacebookCredential : NSObject
+ (instancetype)makeWithAccessToken:(nullable NSString *)accessToken;
@property(nonatomic, copy, nullable) NSString * accessToken;
@end

@interface PhoneOtpCredential : NSObject
+ (instancetype)makeWithPhoneNumber:(nullable NSString *)phoneNumber
    otp:(nullable NSString *)otp;
@property(nonatomic, copy, nullable) NSString * phoneNumber;
@property(nonatomic, copy, nullable) NSString * otp;
@end

@interface UsernamePasswordCredential : NSObject
+ (instancetype)makeWithUsername:(nullable NSString *)username
    password:(nullable NSString *)password;
@property(nonatomic, copy, nullable) NSString * username;
@property(nonatomic, copy, nullable) NSString * password;
@end

@interface CustomCredential : NSObject
+ (instancetype)makeWithIdToken:(nullable NSString *)idToken;
@property(nonatomic, copy, nullable) NSString * idToken;
@end

@interface UserInfoResult : NSObject
+ (instancetype)makeWithUserInfo:(nullable UserInfo *)userInfo
    isSuccess:(nullable NSNumber *)isSuccess
    error:(nullable NSString *)error;
@property(nonatomic, strong, nullable) UserInfo * userInfo;
@property(nonatomic, strong, nullable) NSNumber * isSuccess;
@property(nonatomic, copy, nullable) NSString * error;
@end

@interface UserInfo : NSObject
+ (instancetype)makeWithSub:(nullable NSString *)sub
    name:(nullable NSString *)name
    picture:(nullable NSString *)picture
    email:(nullable NSString *)email
    phoneNumber:(nullable NSString *)phoneNumber
    birthday:(nullable NSString *)birthday
    address:(nullable NSString *)address
    roles:(nullable NSArray<NSString *> *)roles
    permissions:(nullable NSArray<NSString *> *)permissions
    metadata:(nullable NSDictionary<NSString *, id> *)metadata;
@property(nonatomic, copy, nullable) NSString * sub;
@property(nonatomic, copy, nullable) NSString * name;
@property(nonatomic, copy, nullable) NSString * picture;
@property(nonatomic, copy, nullable) NSString * email;
@property(nonatomic, copy, nullable) NSString * phoneNumber;
@property(nonatomic, copy, nullable) NSString * birthday;
@property(nonatomic, copy, nullable) NSString * address;
@property(nonatomic, strong, nullable) NSArray<NSString *> * roles;
@property(nonatomic, strong, nullable) NSArray<NSString *> * permissions;
@property(nonatomic, strong, nullable) NSDictionary<NSString *, id> * metadata;
@end

/// The codec used by FlutterAuthApi.
NSObject<FlutterMessageCodec> *FlutterAuthApiGetCodec(void);

@protocol FlutterAuthApi
/// @return `nil` only when `error != nil`.
- (nullable CommonAuthResult *)getInstanceAppName:(NSString *)appName error:(FlutterError *_Nullable *_Nonnull)error;
- (void)isAuthorizedAppName:(NSString *)appName completion:(void(^)(IsAuthorizedResult *_Nullable, FlutterError *_Nullable))completion;
- (void)getCurrentTokenAppName:(NSString *)appName completion:(void(^)(AccessTokenResult *_Nullable, FlutterError *_Nullable))completion;
- (void)refreshTokenAppName:(NSString *)appName completion:(void(^)(AccessTokenResult *_Nullable, FlutterError *_Nullable))completion;
- (void)exchangeTokenAppName:(NSString *)appName iamAudience:(NSString *)iamAudience completion:(void(^)(IdTokenResult *_Nullable, FlutterError *_Nullable))completion;
- (void)requestOtpAppName:(NSString *)appName phoneNumber:(NSString *)phoneNumber completion:(void(^)(CommonAuthResult *_Nullable, FlutterError *_Nullable))completion;
- (void)loginWithGoogleCredentialAppName:(NSString *)appName credential:(GoogleCredential *)credential completion:(void(^)(CommonAuthResult *_Nullable, FlutterError *_Nullable))completion;
- (void)loginWithFacebookCredentialAppName:(NSString *)appName credential:(FacebookCredential *)credential completion:(void(^)(CommonAuthResult *_Nullable, FlutterError *_Nullable))completion;
- (void)loginWithAppleCredentialAppName:(NSString *)appName credential:(AppleCredential *)credential completion:(void(^)(CommonAuthResult *_Nullable, FlutterError *_Nullable))completion;
- (void)loginWithUsernamePasswordCredentialAppName:(NSString *)appName credential:(UsernamePasswordCredential *)credential completion:(void(^)(CommonAuthResult *_Nullable, FlutterError *_Nullable))completion;
- (void)loginWithPhoneOtpCredentialAppName:(NSString *)appName credential:(PhoneOtpCredential *)credential completion:(void(^)(CommonAuthResult *_Nullable, FlutterError *_Nullable))completion;
- (void)loginWithCustomCredentialAppName:(NSString *)appName credential:(CustomCredential *)credential completion:(void(^)(CommonAuthResult *_Nullable, FlutterError *_Nullable))completion;
- (void)loginWithGoogleAppName:(NSString *)appName completion:(void(^)(CommonAuthResult *_Nullable, FlutterError *_Nullable))completion;
- (void)loginWithFacebookAppName:(NSString *)appName completion:(void(^)(CommonAuthResult *_Nullable, FlutterError *_Nullable))completion;
- (void)loginWithAppleAppName:(NSString *)appName completion:(void(^)(CommonAuthResult *_Nullable, FlutterError *_Nullable))completion;
- (void)logoutAppName:(NSString *)appName completion:(void(^)(LogoutResult *_Nullable, FlutterError *_Nullable))completion;
- (void)getUserInfoAppName:(NSString *)appName completion:(void(^)(UserInfoResult *_Nullable, FlutterError *_Nullable))completion;
- (void)verifyPhoneAppName:(NSString *)appName phone:(NSString *)phone completion:(void(^)(CommonAuthResult *_Nullable, FlutterError *_Nullable))completion;
- (void)verifyEmailAppName:(NSString *)appName email:(NSString *)email completion:(void(^)(CommonAuthResult *_Nullable, FlutterError *_Nullable))completion;
- (void)confirmPhoneAppName:(NSString *)appName phone:(NSString *)phone code:(NSString *)code completion:(void(^)(CommonAuthResult *_Nullable, FlutterError *_Nullable))completion;
- (void)confirmEmailAppName:(NSString *)appName email:(NSString *)email code:(NSString *)code completion:(void(^)(CommonAuthResult *_Nullable, FlutterError *_Nullable))completion;
@end

extern void FlutterAuthApiSetup(id<FlutterBinaryMessenger> binaryMessenger, NSObject<FlutterAuthApi> *_Nullable api);

NS_ASSUME_NONNULL_END
