// Autogenerated from Pigeon (v2.0.4), do not edit directly.
// See also: https://pub.dev/packages/pigeon
#import "AuthFlutter.h"
#import <Flutter/Flutter.h>

#if !__has_feature(objc_arc)
#error File requires ARC to be enabled.
#endif

static NSDictionary<NSString *, id> *wrapResult(id result, FlutterError *error) {
  NSDictionary *errorDict = (NSDictionary *)[NSNull null];
  if (error) {
    errorDict = @{
        @"code": (error.code ? error.code : [NSNull null]),
        @"message": (error.message ? error.message : [NSNull null]),
        @"details": (error.details ? error.details : [NSNull null]),
        };
  }
  return @{
      @"result": (result ? result : [NSNull null]),
      @"error": errorDict,
      };
}
static id GetNullableObject(NSDictionary* dict, id key) {
  id result = dict[key];
  return (result == [NSNull null]) ? nil : result;
}
static id GetNullableObjectAtIndex(NSArray* array, NSInteger key) {
  id result = array[key];
  return (result == [NSNull null]) ? nil : result;
}


@interface CommonAuthResult ()
+ (CommonAuthResult *)fromMap:(NSDictionary *)dict;
- (NSDictionary *)toMap;
@end
@interface IsAuthorizedResult ()
+ (IsAuthorizedResult *)fromMap:(NSDictionary *)dict;
- (NSDictionary *)toMap;
@end
@interface LogoutResult ()
+ (LogoutResult *)fromMap:(NSDictionary *)dict;
- (NSDictionary *)toMap;
@end
@interface AccessTokenResult ()
+ (AccessTokenResult *)fromMap:(NSDictionary *)dict;
- (NSDictionary *)toMap;
@end
@interface IdTokenResult ()
+ (IdTokenResult *)fromMap:(NSDictionary *)dict;
- (NSDictionary *)toMap;
@end
@interface IamToken ()
+ (IamToken *)fromMap:(NSDictionary *)dict;
- (NSDictionary *)toMap;
@end
@interface IdToken ()
+ (IdToken *)fromMap:(NSDictionary *)dict;
- (NSDictionary *)toMap;
@end
@interface AppleCredential ()
+ (AppleCredential *)fromMap:(NSDictionary *)dict;
- (NSDictionary *)toMap;
@end
@interface GoogleCredential ()
+ (GoogleCredential *)fromMap:(NSDictionary *)dict;
- (NSDictionary *)toMap;
@end
@interface FacebookCredential ()
+ (FacebookCredential *)fromMap:(NSDictionary *)dict;
- (NSDictionary *)toMap;
@end
@interface PhoneOtpCredential ()
+ (PhoneOtpCredential *)fromMap:(NSDictionary *)dict;
- (NSDictionary *)toMap;
@end
@interface UsernamePasswordCredential ()
+ (UsernamePasswordCredential *)fromMap:(NSDictionary *)dict;
- (NSDictionary *)toMap;
@end
@interface CustomCredential ()
+ (CustomCredential *)fromMap:(NSDictionary *)dict;
- (NSDictionary *)toMap;
@end
@interface UserInfoResult ()
+ (UserInfoResult *)fromMap:(NSDictionary *)dict;
- (NSDictionary *)toMap;
@end
@interface UserInfo ()
+ (UserInfo *)fromMap:(NSDictionary *)dict;
- (NSDictionary *)toMap;
@end

@implementation CommonAuthResult
+ (instancetype)makeWithIsSuccess:(nullable NSNumber *)isSuccess
    error:(nullable NSString *)error {
  CommonAuthResult* pigeonResult = [[CommonAuthResult alloc] init];
  pigeonResult.isSuccess = isSuccess;
  pigeonResult.error = error;
  return pigeonResult;
}
+ (CommonAuthResult *)fromMap:(NSDictionary *)dict {
  CommonAuthResult *pigeonResult = [[CommonAuthResult alloc] init];
  pigeonResult.isSuccess = GetNullableObject(dict, @"isSuccess");
  pigeonResult.error = GetNullableObject(dict, @"error");
  return pigeonResult;
}
- (NSDictionary *)toMap {
  return [NSDictionary dictionaryWithObjectsAndKeys:(self.isSuccess ? self.isSuccess : [NSNull null]), @"isSuccess", (self.error ? self.error : [NSNull null]), @"error", nil];
}
@end

@implementation IsAuthorizedResult
+ (instancetype)makeWithIsAuthorized:(nullable NSNumber *)isAuthorized
    isSuccess:(nullable NSNumber *)isSuccess
    error:(nullable NSString *)error {
  IsAuthorizedResult* pigeonResult = [[IsAuthorizedResult alloc] init];
  pigeonResult.isAuthorized = isAuthorized;
  pigeonResult.isSuccess = isSuccess;
  pigeonResult.error = error;
  return pigeonResult;
}
+ (IsAuthorizedResult *)fromMap:(NSDictionary *)dict {
  IsAuthorizedResult *pigeonResult = [[IsAuthorizedResult alloc] init];
  pigeonResult.isAuthorized = GetNullableObject(dict, @"isAuthorized");
  pigeonResult.isSuccess = GetNullableObject(dict, @"isSuccess");
  pigeonResult.error = GetNullableObject(dict, @"error");
  return pigeonResult;
}
- (NSDictionary *)toMap {
  return [NSDictionary dictionaryWithObjectsAndKeys:(self.isAuthorized ? self.isAuthorized : [NSNull null]), @"isAuthorized", (self.isSuccess ? self.isSuccess : [NSNull null]), @"isSuccess", (self.error ? self.error : [NSNull null]), @"error", nil];
}
@end

@implementation LogoutResult
+ (instancetype)makeWithIsLoggedOut:(nullable NSNumber *)isLoggedOut
    isSuccess:(nullable NSNumber *)isSuccess
    error:(nullable NSString *)error {
  LogoutResult* pigeonResult = [[LogoutResult alloc] init];
  pigeonResult.isLoggedOut = isLoggedOut;
  pigeonResult.isSuccess = isSuccess;
  pigeonResult.error = error;
  return pigeonResult;
}
+ (LogoutResult *)fromMap:(NSDictionary *)dict {
  LogoutResult *pigeonResult = [[LogoutResult alloc] init];
  pigeonResult.isLoggedOut = GetNullableObject(dict, @"isLoggedOut");
  pigeonResult.isSuccess = GetNullableObject(dict, @"isSuccess");
  pigeonResult.error = GetNullableObject(dict, @"error");
  return pigeonResult;
}
- (NSDictionary *)toMap {
  return [NSDictionary dictionaryWithObjectsAndKeys:(self.isLoggedOut ? self.isLoggedOut : [NSNull null]), @"isLoggedOut", (self.isSuccess ? self.isSuccess : [NSNull null]), @"isSuccess", (self.error ? self.error : [NSNull null]), @"error", nil];
}
@end

@implementation AccessTokenResult
+ (instancetype)makeWithIsSuccess:(nullable NSNumber *)isSuccess
    error:(nullable NSString *)error
    iamToken:(nullable IamToken *)iamToken {
  AccessTokenResult* pigeonResult = [[AccessTokenResult alloc] init];
  pigeonResult.isSuccess = isSuccess;
  pigeonResult.error = error;
  pigeonResult.iamToken = iamToken;
  return pigeonResult;
}
+ (AccessTokenResult *)fromMap:(NSDictionary *)dict {
  AccessTokenResult *pigeonResult = [[AccessTokenResult alloc] init];
  pigeonResult.isSuccess = GetNullableObject(dict, @"isSuccess");
  pigeonResult.error = GetNullableObject(dict, @"error");
  pigeonResult.iamToken = [IamToken fromMap:GetNullableObject(dict, @"iamToken")];
  return pigeonResult;
}
- (NSDictionary *)toMap {
  return [NSDictionary dictionaryWithObjectsAndKeys:(self.isSuccess ? self.isSuccess : [NSNull null]), @"isSuccess", (self.error ? self.error : [NSNull null]), @"error", (self.iamToken ? [self.iamToken toMap] : [NSNull null]), @"iamToken", nil];
}
@end

@implementation IdTokenResult
+ (instancetype)makeWithIsSuccess:(nullable NSNumber *)isSuccess
    error:(nullable NSString *)error
    idToken:(nullable IdToken *)idToken {
  IdTokenResult* pigeonResult = [[IdTokenResult alloc] init];
  pigeonResult.isSuccess = isSuccess;
  pigeonResult.error = error;
  pigeonResult.idToken = idToken;
  return pigeonResult;
}
+ (IdTokenResult *)fromMap:(NSDictionary *)dict {
  IdTokenResult *pigeonResult = [[IdTokenResult alloc] init];
  pigeonResult.isSuccess = GetNullableObject(dict, @"isSuccess");
  pigeonResult.error = GetNullableObject(dict, @"error");
  pigeonResult.idToken = [IdToken fromMap:GetNullableObject(dict, @"idToken")];
  return pigeonResult;
}
- (NSDictionary *)toMap {
  return [NSDictionary dictionaryWithObjectsAndKeys:(self.isSuccess ? self.isSuccess : [NSNull null]), @"isSuccess", (self.error ? self.error : [NSNull null]), @"error", (self.idToken ? [self.idToken toMap] : [NSNull null]), @"idToken", nil];
}
@end

@implementation IamToken
+ (instancetype)makeWithId:(nullable NSString *)id
    accessToken:(nullable NSString *)accessToken
    refreshToken:(nullable NSString *)refreshToken
    expiresIn:(nullable NSNumber *)expiresIn
    tokenType:(nullable NSString *)tokenType {
  IamToken* pigeonResult = [[IamToken alloc] init];
  pigeonResult.id = id;
  pigeonResult.accessToken = accessToken;
  pigeonResult.refreshToken = refreshToken;
  pigeonResult.expiresIn = expiresIn;
  pigeonResult.tokenType = tokenType;
  return pigeonResult;
}
+ (IamToken *)fromMap:(NSDictionary *)dict {
  IamToken *pigeonResult = [[IamToken alloc] init];
  pigeonResult.id = GetNullableObject(dict, @"id");
  pigeonResult.accessToken = GetNullableObject(dict, @"accessToken");
  pigeonResult.refreshToken = GetNullableObject(dict, @"refreshToken");
  pigeonResult.expiresIn = GetNullableObject(dict, @"expiresIn");
  pigeonResult.tokenType = GetNullableObject(dict, @"tokenType");
  return pigeonResult;
}
- (NSDictionary *)toMap {
  return [NSDictionary dictionaryWithObjectsAndKeys:(self.id ? self.id : [NSNull null]), @"id", (self.accessToken ? self.accessToken : [NSNull null]), @"accessToken", (self.refreshToken ? self.refreshToken : [NSNull null]), @"refreshToken", (self.expiresIn ? self.expiresIn : [NSNull null]), @"expiresIn", (self.tokenType ? self.tokenType : [NSNull null]), @"tokenType", nil];
}
@end

@implementation IdToken
+ (instancetype)makeWithIdToken:(nullable NSString *)idToken
    accessToken:(nullable NSString *)accessToken
    refreshToken:(nullable NSString *)refreshToken
    expiresIn:(nullable NSNumber *)expiresIn
    tokenType:(nullable NSString *)tokenType {
  IdToken* pigeonResult = [[IdToken alloc] init];
  pigeonResult.idToken = idToken;
  pigeonResult.accessToken = accessToken;
  pigeonResult.refreshToken = refreshToken;
  pigeonResult.expiresIn = expiresIn;
  pigeonResult.tokenType = tokenType;
  return pigeonResult;
}
+ (IdToken *)fromMap:(NSDictionary *)dict {
  IdToken *pigeonResult = [[IdToken alloc] init];
  pigeonResult.idToken = GetNullableObject(dict, @"idToken");
  pigeonResult.accessToken = GetNullableObject(dict, @"accessToken");
  pigeonResult.refreshToken = GetNullableObject(dict, @"refreshToken");
  pigeonResult.expiresIn = GetNullableObject(dict, @"expiresIn");
  pigeonResult.tokenType = GetNullableObject(dict, @"tokenType");
  return pigeonResult;
}
- (NSDictionary *)toMap {
  return [NSDictionary dictionaryWithObjectsAndKeys:(self.idToken ? self.idToken : [NSNull null]), @"idToken", (self.accessToken ? self.accessToken : [NSNull null]), @"accessToken", (self.refreshToken ? self.refreshToken : [NSNull null]), @"refreshToken", (self.expiresIn ? self.expiresIn : [NSNull null]), @"expiresIn", (self.tokenType ? self.tokenType : [NSNull null]), @"tokenType", nil];
}
@end

@implementation AppleCredential
+ (instancetype)makeWithAccessToken:(nullable NSString *)accessToken {
  AppleCredential* pigeonResult = [[AppleCredential alloc] init];
  pigeonResult.accessToken = accessToken;
  return pigeonResult;
}
+ (AppleCredential *)fromMap:(NSDictionary *)dict {
  AppleCredential *pigeonResult = [[AppleCredential alloc] init];
  pigeonResult.accessToken = GetNullableObject(dict, @"accessToken");
  return pigeonResult;
}
- (NSDictionary *)toMap {
  return [NSDictionary dictionaryWithObjectsAndKeys:(self.accessToken ? self.accessToken : [NSNull null]), @"accessToken", nil];
}
@end

@implementation GoogleCredential
+ (instancetype)makeWithAccessToken:(nullable NSString *)accessToken {
  GoogleCredential* pigeonResult = [[GoogleCredential alloc] init];
  pigeonResult.accessToken = accessToken;
  return pigeonResult;
}
+ (GoogleCredential *)fromMap:(NSDictionary *)dict {
  GoogleCredential *pigeonResult = [[GoogleCredential alloc] init];
  pigeonResult.accessToken = GetNullableObject(dict, @"accessToken");
  return pigeonResult;
}
- (NSDictionary *)toMap {
  return [NSDictionary dictionaryWithObjectsAndKeys:(self.accessToken ? self.accessToken : [NSNull null]), @"accessToken", nil];
}
@end

@implementation FacebookCredential
+ (instancetype)makeWithAccessToken:(nullable NSString *)accessToken {
  FacebookCredential* pigeonResult = [[FacebookCredential alloc] init];
  pigeonResult.accessToken = accessToken;
  return pigeonResult;
}
+ (FacebookCredential *)fromMap:(NSDictionary *)dict {
  FacebookCredential *pigeonResult = [[FacebookCredential alloc] init];
  pigeonResult.accessToken = GetNullableObject(dict, @"accessToken");
  return pigeonResult;
}
- (NSDictionary *)toMap {
  return [NSDictionary dictionaryWithObjectsAndKeys:(self.accessToken ? self.accessToken : [NSNull null]), @"accessToken", nil];
}
@end

@implementation PhoneOtpCredential
+ (instancetype)makeWithPhoneNumber:(nullable NSString *)phoneNumber
    otp:(nullable NSString *)otp {
  PhoneOtpCredential* pigeonResult = [[PhoneOtpCredential alloc] init];
  pigeonResult.phoneNumber = phoneNumber;
  pigeonResult.otp = otp;
  return pigeonResult;
}
+ (PhoneOtpCredential *)fromMap:(NSDictionary *)dict {
  PhoneOtpCredential *pigeonResult = [[PhoneOtpCredential alloc] init];
  pigeonResult.phoneNumber = GetNullableObject(dict, @"phoneNumber");
  pigeonResult.otp = GetNullableObject(dict, @"otp");
  return pigeonResult;
}
- (NSDictionary *)toMap {
  return [NSDictionary dictionaryWithObjectsAndKeys:(self.phoneNumber ? self.phoneNumber : [NSNull null]), @"phoneNumber", (self.otp ? self.otp : [NSNull null]), @"otp", nil];
}
@end

@implementation UsernamePasswordCredential
+ (instancetype)makeWithUsername:(nullable NSString *)username
    password:(nullable NSString *)password {
  UsernamePasswordCredential* pigeonResult = [[UsernamePasswordCredential alloc] init];
  pigeonResult.username = username;
  pigeonResult.password = password;
  return pigeonResult;
}
+ (UsernamePasswordCredential *)fromMap:(NSDictionary *)dict {
  UsernamePasswordCredential *pigeonResult = [[UsernamePasswordCredential alloc] init];
  pigeonResult.username = GetNullableObject(dict, @"username");
  pigeonResult.password = GetNullableObject(dict, @"password");
  return pigeonResult;
}
- (NSDictionary *)toMap {
  return [NSDictionary dictionaryWithObjectsAndKeys:(self.username ? self.username : [NSNull null]), @"username", (self.password ? self.password : [NSNull null]), @"password", nil];
}
@end

@implementation CustomCredential
+ (instancetype)makeWithIdToken:(nullable NSString *)idToken {
  CustomCredential* pigeonResult = [[CustomCredential alloc] init];
  pigeonResult.idToken = idToken;
  return pigeonResult;
}
+ (CustomCredential *)fromMap:(NSDictionary *)dict {
  CustomCredential *pigeonResult = [[CustomCredential alloc] init];
  pigeonResult.idToken = GetNullableObject(dict, @"idToken");
  return pigeonResult;
}
- (NSDictionary *)toMap {
  return [NSDictionary dictionaryWithObjectsAndKeys:(self.idToken ? self.idToken : [NSNull null]), @"idToken", nil];
}
@end

@implementation UserInfoResult
+ (instancetype)makeWithUserInfo:(nullable UserInfo *)userInfo
    isSuccess:(nullable NSNumber *)isSuccess
    error:(nullable NSString *)error {
  UserInfoResult* pigeonResult = [[UserInfoResult alloc] init];
  pigeonResult.userInfo = userInfo;
  pigeonResult.isSuccess = isSuccess;
  pigeonResult.error = error;
  return pigeonResult;
}
+ (UserInfoResult *)fromMap:(NSDictionary *)dict {
  UserInfoResult *pigeonResult = [[UserInfoResult alloc] init];
  pigeonResult.userInfo = [UserInfo fromMap:GetNullableObject(dict, @"userInfo")];
  pigeonResult.isSuccess = GetNullableObject(dict, @"isSuccess");
  pigeonResult.error = GetNullableObject(dict, @"error");
  return pigeonResult;
}
- (NSDictionary *)toMap {
  return [NSDictionary dictionaryWithObjectsAndKeys:(self.userInfo ? [self.userInfo toMap] : [NSNull null]), @"userInfo", (self.isSuccess ? self.isSuccess : [NSNull null]), @"isSuccess", (self.error ? self.error : [NSNull null]), @"error", nil];
}
@end

@implementation UserInfo
+ (instancetype)makeWithSub:(nullable NSString *)sub
    name:(nullable NSString *)name
    picture:(nullable NSString *)picture
    email:(nullable NSString *)email
    phoneNumber:(nullable NSString *)phoneNumber
    birthday:(nullable NSString *)birthday
    address:(nullable NSString *)address
    roles:(nullable NSArray<NSString *> *)roles
    permissions:(nullable NSArray<NSString *> *)permissions
    metadata:(nullable NSDictionary<NSString *, id> *)metadata {
  UserInfo* pigeonResult = [[UserInfo alloc] init];
  pigeonResult.sub = sub;
  pigeonResult.name = name;
  pigeonResult.picture = picture;
  pigeonResult.email = email;
  pigeonResult.phoneNumber = phoneNumber;
  pigeonResult.birthday = birthday;
  pigeonResult.address = address;
  pigeonResult.roles = roles;
  pigeonResult.permissions = permissions;
  pigeonResult.metadata = metadata;
  return pigeonResult;
}
+ (UserInfo *)fromMap:(NSDictionary *)dict {
  UserInfo *pigeonResult = [[UserInfo alloc] init];
  pigeonResult.sub = GetNullableObject(dict, @"sub");
  pigeonResult.name = GetNullableObject(dict, @"name");
  pigeonResult.picture = GetNullableObject(dict, @"picture");
  pigeonResult.email = GetNullableObject(dict, @"email");
  pigeonResult.phoneNumber = GetNullableObject(dict, @"phoneNumber");
  pigeonResult.birthday = GetNullableObject(dict, @"birthday");
  pigeonResult.address = GetNullableObject(dict, @"address");
  pigeonResult.roles = GetNullableObject(dict, @"roles");
  pigeonResult.permissions = GetNullableObject(dict, @"permissions");
  pigeonResult.metadata = GetNullableObject(dict, @"metadata");
  return pigeonResult;
}
- (NSDictionary *)toMap {
  return [NSDictionary dictionaryWithObjectsAndKeys:(self.sub ? self.sub : [NSNull null]), @"sub", (self.name ? self.name : [NSNull null]), @"name", (self.picture ? self.picture : [NSNull null]), @"picture", (self.email ? self.email : [NSNull null]), @"email", (self.phoneNumber ? self.phoneNumber : [NSNull null]), @"phoneNumber", (self.birthday ? self.birthday : [NSNull null]), @"birthday", (self.address ? self.address : [NSNull null]), @"address", (self.roles ? self.roles : [NSNull null]), @"roles", (self.permissions ? self.permissions : [NSNull null]), @"permissions", (self.metadata ? self.metadata : [NSNull null]), @"metadata", nil];
}
@end

@interface FlutterAuthApiCodecReader : FlutterStandardReader
@end
@implementation FlutterAuthApiCodecReader
- (nullable id)readValueOfType:(UInt8)type 
{
  switch (type) {
    case 128:     
      return [AccessTokenResult fromMap:[self readValue]];
    
    case 129:     
      return [AppleCredential fromMap:[self readValue]];
    
    case 130:     
      return [CommonAuthResult fromMap:[self readValue]];
    
    case 131:     
      return [CustomCredential fromMap:[self readValue]];
    
    case 132:     
      return [FacebookCredential fromMap:[self readValue]];
    
    case 133:     
      return [GoogleCredential fromMap:[self readValue]];
    
    case 134:     
      return [IamToken fromMap:[self readValue]];
    
    case 135:     
      return [IdToken fromMap:[self readValue]];
    
    case 136:     
      return [IdTokenResult fromMap:[self readValue]];
    
    case 137:     
      return [IsAuthorizedResult fromMap:[self readValue]];
    
    case 138:     
      return [LogoutResult fromMap:[self readValue]];
    
    case 139:     
      return [PhoneOtpCredential fromMap:[self readValue]];
    
    case 140:     
      return [UserInfo fromMap:[self readValue]];
    
    case 141:     
      return [UserInfoResult fromMap:[self readValue]];
    
    case 142:     
      return [UsernamePasswordCredential fromMap:[self readValue]];
    
    default:    
      return [super readValueOfType:type];
    
  }
}
@end

@interface FlutterAuthApiCodecWriter : FlutterStandardWriter
@end
@implementation FlutterAuthApiCodecWriter
- (void)writeValue:(id)value 
{
  if ([value isKindOfClass:[AccessTokenResult class]]) {
    [self writeByte:128];
    [self writeValue:[value toMap]];
  } else 
  if ([value isKindOfClass:[AppleCredential class]]) {
    [self writeByte:129];
    [self writeValue:[value toMap]];
  } else 
  if ([value isKindOfClass:[CommonAuthResult class]]) {
    [self writeByte:130];
    [self writeValue:[value toMap]];
  } else 
  if ([value isKindOfClass:[CustomCredential class]]) {
    [self writeByte:131];
    [self writeValue:[value toMap]];
  } else 
  if ([value isKindOfClass:[FacebookCredential class]]) {
    [self writeByte:132];
    [self writeValue:[value toMap]];
  } else 
  if ([value isKindOfClass:[GoogleCredential class]]) {
    [self writeByte:133];
    [self writeValue:[value toMap]];
  } else 
  if ([value isKindOfClass:[IamToken class]]) {
    [self writeByte:134];
    [self writeValue:[value toMap]];
  } else 
  if ([value isKindOfClass:[IdToken class]]) {
    [self writeByte:135];
    [self writeValue:[value toMap]];
  } else 
  if ([value isKindOfClass:[IdTokenResult class]]) {
    [self writeByte:136];
    [self writeValue:[value toMap]];
  } else 
  if ([value isKindOfClass:[IsAuthorizedResult class]]) {
    [self writeByte:137];
    [self writeValue:[value toMap]];
  } else 
  if ([value isKindOfClass:[LogoutResult class]]) {
    [self writeByte:138];
    [self writeValue:[value toMap]];
  } else 
  if ([value isKindOfClass:[PhoneOtpCredential class]]) {
    [self writeByte:139];
    [self writeValue:[value toMap]];
  } else 
  if ([value isKindOfClass:[UserInfo class]]) {
    [self writeByte:140];
    [self writeValue:[value toMap]];
  } else 
  if ([value isKindOfClass:[UserInfoResult class]]) {
    [self writeByte:141];
    [self writeValue:[value toMap]];
  } else 
  if ([value isKindOfClass:[UsernamePasswordCredential class]]) {
    [self writeByte:142];
    [self writeValue:[value toMap]];
  } else 
{
    [super writeValue:value];
  }
}
@end

@interface FlutterAuthApiCodecReaderWriter : FlutterStandardReaderWriter
@end
@implementation FlutterAuthApiCodecReaderWriter
- (FlutterStandardWriter *)writerWithData:(NSMutableData *)data {
  return [[FlutterAuthApiCodecWriter alloc] initWithData:data];
}
- (FlutterStandardReader *)readerWithData:(NSData *)data {
  return [[FlutterAuthApiCodecReader alloc] initWithData:data];
}
@end

NSObject<FlutterMessageCodec> *FlutterAuthApiGetCodec() {
  static dispatch_once_t sPred = 0;
  static FlutterStandardMessageCodec *sSharedObject = nil;
  dispatch_once(&sPred, ^{
    FlutterAuthApiCodecReaderWriter *readerWriter = [[FlutterAuthApiCodecReaderWriter alloc] init];
    sSharedObject = [FlutterStandardMessageCodec codecWithReaderWriter:readerWriter];
  });
  return sSharedObject;
}


void FlutterAuthApiSetup(id<FlutterBinaryMessenger> binaryMessenger, NSObject<FlutterAuthApi> *api) {
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.FlutterAuthApi.getInstance"
        binaryMessenger:binaryMessenger
        codec:FlutterAuthApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(getInstanceAppName:error:)], @"FlutterAuthApi api (%@) doesn't respond to @selector(getInstanceAppName:error:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_appName = GetNullableObjectAtIndex(args, 0);
        FlutterError *error;
        CommonAuthResult *output = [api getInstanceAppName:arg_appName error:&error];
        callback(wrapResult(output, error));
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.FlutterAuthApi.isAuthorized"
        binaryMessenger:binaryMessenger
        codec:FlutterAuthApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(isAuthorizedAppName:completion:)], @"FlutterAuthApi api (%@) doesn't respond to @selector(isAuthorizedAppName:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_appName = GetNullableObjectAtIndex(args, 0);
        [api isAuthorizedAppName:arg_appName completion:^(IsAuthorizedResult *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.FlutterAuthApi.getCurrentToken"
        binaryMessenger:binaryMessenger
        codec:FlutterAuthApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(getCurrentTokenAppName:completion:)], @"FlutterAuthApi api (%@) doesn't respond to @selector(getCurrentTokenAppName:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_appName = GetNullableObjectAtIndex(args, 0);
        [api getCurrentTokenAppName:arg_appName completion:^(AccessTokenResult *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.FlutterAuthApi.refreshToken"
        binaryMessenger:binaryMessenger
        codec:FlutterAuthApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(refreshTokenAppName:completion:)], @"FlutterAuthApi api (%@) doesn't respond to @selector(refreshTokenAppName:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_appName = GetNullableObjectAtIndex(args, 0);
        [api refreshTokenAppName:arg_appName completion:^(AccessTokenResult *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.FlutterAuthApi.exchangeToken"
        binaryMessenger:binaryMessenger
        codec:FlutterAuthApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(exchangeTokenAppName:iamAudience:completion:)], @"FlutterAuthApi api (%@) doesn't respond to @selector(exchangeTokenAppName:iamAudience:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_appName = GetNullableObjectAtIndex(args, 0);
        NSString *arg_iamAudience = GetNullableObjectAtIndex(args, 1);
        [api exchangeTokenAppName:arg_appName iamAudience:arg_iamAudience completion:^(IdTokenResult *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.FlutterAuthApi.requestOtp"
        binaryMessenger:binaryMessenger
        codec:FlutterAuthApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(requestOtpAppName:phoneNumber:completion:)], @"FlutterAuthApi api (%@) doesn't respond to @selector(requestOtpAppName:phoneNumber:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_appName = GetNullableObjectAtIndex(args, 0);
        NSString *arg_phoneNumber = GetNullableObjectAtIndex(args, 1);
        [api requestOtpAppName:arg_appName phoneNumber:arg_phoneNumber completion:^(CommonAuthResult *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.FlutterAuthApi.loginWithGoogleCredential"
        binaryMessenger:binaryMessenger
        codec:FlutterAuthApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(loginWithGoogleCredentialAppName:credential:completion:)], @"FlutterAuthApi api (%@) doesn't respond to @selector(loginWithGoogleCredentialAppName:credential:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_appName = GetNullableObjectAtIndex(args, 0);
        GoogleCredential *arg_credential = GetNullableObjectAtIndex(args, 1);
        [api loginWithGoogleCredentialAppName:arg_appName credential:arg_credential completion:^(CommonAuthResult *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.FlutterAuthApi.loginWithFacebookCredential"
        binaryMessenger:binaryMessenger
        codec:FlutterAuthApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(loginWithFacebookCredentialAppName:credential:completion:)], @"FlutterAuthApi api (%@) doesn't respond to @selector(loginWithFacebookCredentialAppName:credential:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_appName = GetNullableObjectAtIndex(args, 0);
        FacebookCredential *arg_credential = GetNullableObjectAtIndex(args, 1);
        [api loginWithFacebookCredentialAppName:arg_appName credential:arg_credential completion:^(CommonAuthResult *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.FlutterAuthApi.loginWithAppleCredential"
        binaryMessenger:binaryMessenger
        codec:FlutterAuthApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(loginWithAppleCredentialAppName:credential:completion:)], @"FlutterAuthApi api (%@) doesn't respond to @selector(loginWithAppleCredentialAppName:credential:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_appName = GetNullableObjectAtIndex(args, 0);
        AppleCredential *arg_credential = GetNullableObjectAtIndex(args, 1);
        [api loginWithAppleCredentialAppName:arg_appName credential:arg_credential completion:^(CommonAuthResult *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.FlutterAuthApi.loginWithUsernamePasswordCredential"
        binaryMessenger:binaryMessenger
        codec:FlutterAuthApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(loginWithUsernamePasswordCredentialAppName:credential:completion:)], @"FlutterAuthApi api (%@) doesn't respond to @selector(loginWithUsernamePasswordCredentialAppName:credential:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_appName = GetNullableObjectAtIndex(args, 0);
        UsernamePasswordCredential *arg_credential = GetNullableObjectAtIndex(args, 1);
        [api loginWithUsernamePasswordCredentialAppName:arg_appName credential:arg_credential completion:^(CommonAuthResult *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.FlutterAuthApi.loginWithPhoneOtpCredential"
        binaryMessenger:binaryMessenger
        codec:FlutterAuthApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(loginWithPhoneOtpCredentialAppName:credential:completion:)], @"FlutterAuthApi api (%@) doesn't respond to @selector(loginWithPhoneOtpCredentialAppName:credential:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_appName = GetNullableObjectAtIndex(args, 0);
        PhoneOtpCredential *arg_credential = GetNullableObjectAtIndex(args, 1);
        [api loginWithPhoneOtpCredentialAppName:arg_appName credential:arg_credential completion:^(CommonAuthResult *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.FlutterAuthApi.loginWithCustomCredential"
        binaryMessenger:binaryMessenger
        codec:FlutterAuthApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(loginWithCustomCredentialAppName:credential:completion:)], @"FlutterAuthApi api (%@) doesn't respond to @selector(loginWithCustomCredentialAppName:credential:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_appName = GetNullableObjectAtIndex(args, 0);
        CustomCredential *arg_credential = GetNullableObjectAtIndex(args, 1);
        [api loginWithCustomCredentialAppName:arg_appName credential:arg_credential completion:^(CommonAuthResult *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.FlutterAuthApi.loginWithGoogle"
        binaryMessenger:binaryMessenger
        codec:FlutterAuthApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(loginWithGoogleAppName:completion:)], @"FlutterAuthApi api (%@) doesn't respond to @selector(loginWithGoogleAppName:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_appName = GetNullableObjectAtIndex(args, 0);
        [api loginWithGoogleAppName:arg_appName completion:^(CommonAuthResult *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.FlutterAuthApi.loginWithFacebook"
        binaryMessenger:binaryMessenger
        codec:FlutterAuthApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(loginWithFacebookAppName:completion:)], @"FlutterAuthApi api (%@) doesn't respond to @selector(loginWithFacebookAppName:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_appName = GetNullableObjectAtIndex(args, 0);
        [api loginWithFacebookAppName:arg_appName completion:^(CommonAuthResult *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.FlutterAuthApi.loginWithApple"
        binaryMessenger:binaryMessenger
        codec:FlutterAuthApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(loginWithAppleAppName:completion:)], @"FlutterAuthApi api (%@) doesn't respond to @selector(loginWithAppleAppName:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_appName = GetNullableObjectAtIndex(args, 0);
        [api loginWithAppleAppName:arg_appName completion:^(CommonAuthResult *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.FlutterAuthApi.logout"
        binaryMessenger:binaryMessenger
        codec:FlutterAuthApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(logoutAppName:completion:)], @"FlutterAuthApi api (%@) doesn't respond to @selector(logoutAppName:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_appName = GetNullableObjectAtIndex(args, 0);
        [api logoutAppName:arg_appName completion:^(LogoutResult *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.FlutterAuthApi.getUserInfo"
        binaryMessenger:binaryMessenger
        codec:FlutterAuthApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(getUserInfoAppName:completion:)], @"FlutterAuthApi api (%@) doesn't respond to @selector(getUserInfoAppName:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_appName = GetNullableObjectAtIndex(args, 0);
        [api getUserInfoAppName:arg_appName completion:^(UserInfoResult *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.FlutterAuthApi.verifyPhone"
        binaryMessenger:binaryMessenger
        codec:FlutterAuthApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(verifyPhoneAppName:phone:completion:)], @"FlutterAuthApi api (%@) doesn't respond to @selector(verifyPhoneAppName:phone:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_appName = GetNullableObjectAtIndex(args, 0);
        NSString *arg_phone = GetNullableObjectAtIndex(args, 1);
        [api verifyPhoneAppName:arg_appName phone:arg_phone completion:^(CommonAuthResult *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.FlutterAuthApi.verifyEmail"
        binaryMessenger:binaryMessenger
        codec:FlutterAuthApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(verifyEmailAppName:email:completion:)], @"FlutterAuthApi api (%@) doesn't respond to @selector(verifyEmailAppName:email:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_appName = GetNullableObjectAtIndex(args, 0);
        NSString *arg_email = GetNullableObjectAtIndex(args, 1);
        [api verifyEmailAppName:arg_appName email:arg_email completion:^(CommonAuthResult *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.FlutterAuthApi.confirmPhone"
        binaryMessenger:binaryMessenger
        codec:FlutterAuthApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(confirmPhoneAppName:phone:code:completion:)], @"FlutterAuthApi api (%@) doesn't respond to @selector(confirmPhoneAppName:phone:code:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_appName = GetNullableObjectAtIndex(args, 0);
        NSString *arg_phone = GetNullableObjectAtIndex(args, 1);
        NSString *arg_code = GetNullableObjectAtIndex(args, 2);
        [api confirmPhoneAppName:arg_appName phone:arg_phone code:arg_code completion:^(CommonAuthResult *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.FlutterAuthApi.confirmEmail"
        binaryMessenger:binaryMessenger
        codec:FlutterAuthApiGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(confirmEmailAppName:email:code:completion:)], @"FlutterAuthApi api (%@) doesn't respond to @selector(confirmEmailAppName:email:code:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_appName = GetNullableObjectAtIndex(args, 0);
        NSString *arg_email = GetNullableObjectAtIndex(args, 1);
        NSString *arg_code = GetNullableObjectAtIndex(args, 2);
        [api confirmEmailAppName:arg_appName email:arg_email code:arg_code completion:^(CommonAuthResult *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
}
