//
//  ModelExtension.swift
//  auth_flutter
//
//  Created by Cao Trung on 27/04/2022.
//

import Foundation
import Janus

func createSuccessCommonResult() -> CommonAuthResult {
    let result =  CommonAuthResult();
    result.isSuccess = true
    return result
}

func createErrorCommonResult(error: String? = nil) ->CommonAuthResult {
    let result =  CommonAuthResult();
    result.isSuccess = false
    result.error = error
    return result
}

func createSuccessAccessTokenResult(authInfo: IAuthInfo) -> AccessTokenResult {
    let result =  AccessTokenResult();
    let accessToken =  IamToken();
    accessToken.id = authInfo.idToken
    accessToken.accessToken = authInfo.accessToken
    accessToken.refreshToken = authInfo.refreshToken
    accessToken.expiresIn = NSNumber(value: authInfo.tokenExpiredSec)
    accessToken.tokenType = authInfo.tokenType?.rawValue
    
    result.isSuccess = true
    result.iamToken = accessToken

    return result
}

func createSuccessIdTokenResult(authInfo: IAuthInfo) -> IdTokenResult {
    let result =  IdTokenResult();
    let idToken =  IdToken();
    idToken.idToken = authInfo.idToken
    idToken.accessToken = authInfo.accessToken
    idToken.refreshToken = authInfo.refreshToken
    idToken.expiresIn = NSNumber(value: authInfo.tokenExpiredSec)
    idToken.tokenType = authInfo.tokenType?.rawValue
    
    result.isSuccess = true
    result.idToken = idToken
    
    return result
}

func createErrorAccessTokenResult(error: String?) -> AccessTokenResult {
    let result =  AccessTokenResult();
    result.isSuccess = false
    result.error = error
    return result
}

func createErrorIdTokenResult(error: String?) -> IdTokenResult {
    let result =  IdTokenResult();
    result.isSuccess = false
    result.error = error
    return result
}
