import 'package:auth_flutter/model/user_info.dart';
import 'package:auth_flutter/src/auth_api.dart' as pigeon;
import 'package:auth_flutter/src/extension/string.dart';

import '../model/iam_token.dart';
import '../model/id_token.dart';

class ModelUtils {
  ModelUtils._();

  static IdToken createIdTokenFromPigeon(pigeon.IdToken pigeonIdToken) {
    return IdToken(
      pigeonIdToken.idToken.orEmpty,
      pigeonIdToken.accessToken.orEmpty,
      pigeonIdToken.refreshToken.orEmpty,
      pigeonIdToken.expiresIn ?? 0,
      pigeonIdToken.tokenType.orEmpty,
    );
  }

  static IamToken createTokenFromPigeon(pigeon.IamToken pigeonIamToken) {
    return IamToken(
      pigeonIamToken.id.orEmpty,
      pigeonIamToken.accessToken.orEmpty,
      pigeonIamToken.refreshToken.orEmpty,
      pigeonIamToken.expiresIn ?? 0,
      pigeonIamToken.tokenType.orEmpty,
    );
  }

  static UserInfo createUserInfoFromPigeon(pigeon.UserInfo pigeonUserInfo) {
    return UserInfo(
      pigeonUserInfo.sub,
      pigeonUserInfo.name,
      pigeonUserInfo.picture,
      pigeonUserInfo.email,
      pigeonUserInfo.phoneNumber,
      pigeonUserInfo.birthday,
      pigeonUserInfo.address,
      pigeonUserInfo.roles?.map((e) => e.orEmpty).toList(growable: false) ?? [],
      pigeonUserInfo.permissions?.map((e) => e.orEmpty).toList(growable: false) ?? [],
      pigeonUserInfo.metadata?.map((key, value) => MapEntry(key.orEmpty, value)) ?? {},
    );
  }
}
